
#include <windows.h>
#include <stdio.h>
#include <vfw.h>
#include <math.h>
#include <commctrl.h>  
#include "bmpcnv.h"

#define	VIDEO_TABLEMAX			7
#define ALLOC_BITMAPSIZE	(640*480*4+100000)		// 921,600 Byte + 100,000(\

typedef struct {
	BYTE	b;
	BYTE	g;
	BYTE	r;
	BYTE	dmy;
} RGB32BITTBL,*PRGB32BITTBL;

typedef struct {
	BYTE	b;
	BYTE	g;
	BYTE	r;
} BITRGBTBL,*PBITRGBTBL;

typedef struct {
	BYTE	b;
	BYTE	g;
	BYTE	r;
} RGB24BITTBL,*PRGB24BITTBL;

typedef struct {
	WORD	rgb;
}  RGB16BITTBL,*PRGB16BITTBL;


int  APIENTRY	BitDispWindSet (long no,HWND hWnd);
int  APIENTRY	BitDispWindReset (long no);



static	OPENFILENAME	ofh;
static	BYTE			fnm[1024];
static	BYTE			flt[1024];
static	BYTE			idir[1024];


extern	HDRAWDIB	hdrawdibCvb;
extern	PBYTE		pcvbbmp;
extern	PBYTE		pcvbbwk;
extern	PBYTE		pcvbjpg;
static	CRITICAL_SECTION	BmpCnv_Critical;

		int		BitDispInit_Sw=0;

static	long	WINAPI	Disp_BitmapProc (HWND ,UINT,WPARAM,LPARAM);
static	int		DispWndChk (HWND hWnd);
static  void	Conv16To24 (PRGB24BITTBL intbl,PRGB24BITTBL ottbl);
static	int     GetBmpFile(PBYTE,PBYTE,PBYTE);
static	int	    Get_bmtfile (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf);
//static  int Get_bmtfile_cnvt (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf,int cnvflg);
static	void bitmap_angle (LPBITMAPINFOHEADER,PBYTE,PBYTE,int);
static	void Video_Disp (HWND hWnd,PBYTE buf);
static int	bitscalecnv (PBYTE ibf,PBYTE obf,int scl);
static int	Video_MonoColorSet (PBYTE rgbbf,long col,long rcol,long gcol,long bcol);
static short redset (short ir,long rcol);
static short greset (short ig,long gcol);
static short bleset (short ib,long bcol);


static	PBYTE	dispptr[VIDEO_TABLEMAX];
static	long	dispsize[VIDEO_TABLEMAX];
static	FARPROC	dispproc[VIDEO_TABLEMAX];
static	HWND	disphwnd[VIDEO_TABLEMAX];
static	int		wndsetsw[VIDEO_TABLEMAX];


static	int	bmapopen_sw=0;
static	int	pcvbbmp_len=0;
static	int	pcvbbwk_len=0;
static	int	pcvbjpg_len=0;
static	int	StartExecSw;
static	HANDLE	StartExec_h;

//*******************

int APIENTRY	StartExec_Set(long version, long revisin)
{
	BYTE	nm[128];
	if (StartExecSw) return 1;

	wsprintf(nm, "VBNETDX-VER%03d-%03d", version, revisin);
	StartExec_h = CreateMutex(0, FALSE, nm);
	ReleaseMutex(StartExec_h);
	StartExecSw = 1;
	return 0;


}
int APIENTRY	EndExec_Set()
{
	if (StartExec_h) {
		CloseHandle(StartExec_h);
	}
	StartExec_h = 0;
	StartExecSw = 0;
	return 0;
}

int APIENTRY	Get_Exec_Mode(long version, long revisin)
{
	BYTE	nm[128];
	HANDLE	nm_h;
	wsprintf(nm, "VBNETDX-VER%03d-%03d", version, revisin);

	nm_h = OpenMutex(MUTEX_ALL_ACCESS, FALSE, nm);
	if (!nm_h) {
		return 0;			// Not Found 
	}
	ReleaseMutex(nm_h);
	CloseHandle(nm_h);
	return 1;		//  Found


}




int APIENTRY GetDirName(PBYTE inidir,PBYTE ifnm,PBYTE filter,HWND twnd)
{
	int		rt;
	int		i;
	int		ln;

	strcpy (fnm,"");
	strcpy (flt,"");
	strcpy (idir,"");
	if (ifnm)	strcpy (fnm,ifnm);
	if (inidir) strcpy (idir,inidir);
	if (filter) {
		ln = strlen(filter);
		for (i=0;i<ln;i++) {
			if (filter[i] < 0x20)	flt[i] = 0;
			else					flt[i] = filter[i];
		}
		flt[i] = 0;
	}
	memset (&ofh,0,sizeof(ofh));
	ofh.lStructSize = sizeof(ofh);
	ofh.hwndOwner = twnd;
	ofh.lpstrFilter = flt;
	ofh.nFilterIndex = 1;
	ofh.lpstrCustomFilter = 0;
	ofh.nMaxCustFilter    = 0;
	ofh.lpstrFile  = fnm;
	ofh.nMaxFile  = sizeof (fnm);
	ofh.lpstrInitialDir = idir;
	ofh.Flags =  OFN_PATHMUSTEXIST |  OFN_NOCHANGEDIR;
	rt = GetOpenFileName ( &ofh);
	if (rt == FALSE) return 1;
	SetWindowText (twnd,fnm);
	return	0;
}
long  APIENTRY  RegEntrySet (PBYTE lpszValue)
{

	int						iret;
	STARTUPINFO				stinf;
	PROCESS_INFORMATION		prcinf;
	BYTE	fnm[1024];

	strcpy (fnm,"regsvr32 ");
	strcat (fnm,lpszValue);
//	iret = MessageBox (NULL,fnm,"RegEntrySet",MB_OK);
	memset ((void *) &stinf,0,sizeof(stinf));
	stinf.cb = sizeof(prcinf);
	memset ((void *) &prcinf,0,sizeof(prcinf));
	iret = CreateProcess (0,fnm,0,0,FALSE,CREATE_NEW_CONSOLE,0,0,&stinf,&prcinf);
	if (iret == 0) {
		return  0;
	}
	WaitForSingleObject (prcinf.hProcess,2000);

	CloseHandle (prcinf.hThread );
	CloseHandle (prcinf.hProcess);
	return 0;
}


int APIENTRY GetTempDir(HWND twnd)
{
	BYTE	tdir[1024];
	int		rt;

	rt = GetTempPath(sizeof(tdir),tdir);
	if (rt) {
		SetWindowText (twnd,tdir);
		return 0;
	}
	rt = GetCurrentDirectory(sizeof(tdir),tdir);
	if (rt) {
		SetWindowText (twnd,tdir);
		return 0;
	}
	return 1;
}

int  APIENTRY	BitMapOpen(HWND cnvwnd,PBYTE bfnm)
{
	BITMAPINFOHEADER	bfmt;
	int					sz;
	int					bsize;
	LPBITMAPFILEHEADER		pbmfhdr;

	pcvbbmp_len = 0;
	sz = GetBmpFile (bfnm,(PBYTE) &bfmt,(PBYTE) pcvbbmp);
	if (sz == 0) return 1;		//* FILE ERROR
	if (bfmt.biCompression == BI_RGB) {
		pcvbbmp_len = sz + sizeof (BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	} else if (	bfmt.biCompression == '024I' ||
				bfmt.biCompression == 'VUYI'	) {
		//******  RGB CONVERT
		bsize = Get_bmtfile (cnvwnd,(LPBITMAPINFOHEADER)&bfmt,
								pcvbbmp+sizeof(BITMAPFILEHEADER),pcvbbwk+sizeof(BITMAPFILEHEADER));
		if (!bsize) return	0; //* BITMAP CONVERT ERROR
		pbmfhdr =(LPBITMAPFILEHEADER) pcvbbwk;
		pbmfhdr->bfType	= 'MB';
		pbmfhdr->bfOffBits =  sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
		pbmfhdr->bfSize    =  pbmfhdr->bfOffBits + bsize;
		pcvbbmp_len = pbmfhdr->bfSize ;
		CopyMemory (pcvbbmp,pcvbbwk,pcvbbmp_len);
	} else {
		return 2; 		//* BITMAP FORMAT ERROR
	}
	bmapopen_sw = 1;
	return 0;

}
int  APIENTRY	BitMapClose()
{
	bmapopen_sw = 0;
	return 0;
}

int  APIENTRY	BmpFileSend (PBYTE	ofnm)
{

	HANDLE		fhndl;
	DWORD		wrtsz;

	if	(bmapopen_sw == 0) return 0; 

	//*  BMP FILE WRITE
	fhndl = CreateFile (ofnm,
					GENERIC_WRITE,
					0,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);

	if (fhndl != INVALID_HANDLE_VALUE) {
		WriteFile (fhndl,pcvbbmp,pcvbbmp_len,&wrtsz,0);
		CloseHandle (fhndl);
		return	(int) wrtsz;
	}
	return 0;
}

int APIENTRY BmptoJpgConvert (int qualty)
{
	int		jsize;
	if	(bmapopen_sw == 0) return 0; 

	jsize = Bmp_Jpg (qualty,(PBYTE) pcvbbmp,pcvbbmp_len,pcvbjpg);
	pcvbjpg_len = jsize;
	return jsize;
}


int  APIENTRY	JpgFileSend (PBYTE	ofnm)
{

	HANDLE		fhndl;
	DWORD		wrtsz;

	if	(bmapopen_sw == 0)	return 0; 
	if	(!pcvbjpg_len)		return 0;

	//*  BMP FILE WRITE
	fhndl = CreateFile (ofnm,
					GENERIC_WRITE,
					0,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);

	if (fhndl != INVALID_HANDLE_VALUE) {
		WriteFile (fhndl,pcvbjpg,pcvbjpg_len,&wrtsz,0);
		CloseHandle (fhndl);
		return	(int) wrtsz;
	}
	return 0;
}



int APIENTRY	BitDispInit (void)
{
	int		i;

	if (BitDispInit_Sw) return 1;
	
	for (i=0;i<VIDEO_TABLEMAX;i++) {
		wndsetsw[i] = 0;
		dispptr[i] = 0;
		dispsize[i] = 0;
		disphwnd[i] = 0;
	}
	BitDispInit_Sw = 1;
	InitializeCriticalSection(&BmpCnv_Critical);

	return 1;
}


int APIENTRY	BitDispEnd (void)
{
	int		i;
	int		ret;

	if (!BitDispInit_Sw) return 0;
	for (i=0;i<VIDEO_TABLEMAX;i++) {
		ret = BitDispWindReset(i);
	}
	for (i=0;i<VIDEO_TABLEMAX;i++) {
		dispptr[i]	= 0;
		dispsize[i] = 0;
	}

	BitDispInit_Sw = 0;
	DeleteCriticalSection(&BmpCnv_Critical);
	return 1;
}


int  APIENTRY	BmpDisp (int no)
{
	HWND	dspwnd;

	if (!BitDispInit_Sw) return 1;
	if	(bmapopen_sw == 0)	return 1; 
	if	(!pcvbbmp_len)		return 1;
	if (no < 0 || no > VIDEO_TABLEMAX) return 1;
	if (!wndsetsw[no]) return 1;
	dspwnd = disphwnd[no];

	CopyMemory (dispptr[no],pcvbbmp,pcvbbmp_len);
	dispsize[no] = pcvbbmp_len;
	EnterCriticalSection(&BmpCnv_Critical);
	Video_Disp (dspwnd,pcvbbmp+sizeof(BITMAPFILEHEADER));
	LeaveCriticalSection(&BmpCnv_Critical);
	return  0;
}

int  APIENTRY	BmpFileDisp (int no,PBYTE bfnm)
{
	int		rt;
	BITMAPINFOHEADER	fmt;
	HWND	dspwnd;
	
	if (!BitDispInit_Sw) return 1;
	if (no < 0 || no > VIDEO_TABLEMAX) return 1;
	if (!wndsetsw[no]) return 1;
	dspwnd = disphwnd[no];

	rt = GetBmpFile (bfnm,(PBYTE) &fmt,(PBYTE) pcvbbwk);
	if (rt) {
		pcvbbwk_len = rt + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
		dispsize[no] = pcvbbwk_len;
		CopyMemory (dispptr[no],pcvbbwk,pcvbbwk_len);
		EnterCriticalSection(&BmpCnv_Critical);
		Video_Disp (dspwnd,pcvbbwk+sizeof(BITMAPFILEHEADER));
		LeaveCriticalSection(&BmpCnv_Critical);
		return  0;
	}
	return 1;
}

int  APIENTRY	BmpDispReset (int no)
{
	dispsize[no] = 0;
	return 0;
}

int  APIENTRY	BmpDispCopy (int fno,int tno)
{
	PBYTE	fpt;
	PBYTE	tpt;
	HWND	dspwnd;

	if (!BitDispInit_Sw) return 1;
	if (!wndsetsw[tno]) return 1;
	if (fno < 0 || fno > VIDEO_TABLEMAX) return 1;
	if (tno < 0 || tno > VIDEO_TABLEMAX) return 1;
	if (dispsize[fno] == 0) return 1;
	
	fpt = dispptr[fno];
	tpt = dispptr[tno];
	dispsize[tno] = dispsize[fno];
	CopyMemory (tpt,fpt,dispsize[fno]);
	dspwnd = disphwnd[tno];
	EnterCriticalSection(&BmpCnv_Critical);
	Video_Disp (dspwnd,tpt+sizeof(BITMAPFILEHEADER));
	LeaveCriticalSection(&BmpCnv_Critical);
	return 0;
}

int  APIENTRY	BmpScalConv (int cnvangle,int cnvscal)
{

	BITMAPINFOHEADER	bfmt;
	int		bhdsize=sizeof(BITMAPFILEHEADER);
	int		bifsize=sizeof(BITMAPINFOHEADER);

	if	(bmapopen_sw == 0)	return 1; 
	if	(!pcvbbmp_len)		return 1;

	CopyMemory ((PBYTE)&bfmt,(PBYTE)pcvbbmp+bhdsize,bifsize);
	bitmap_angle ((LPBITMAPINFOHEADER)&bfmt,
							pcvbbmp+bhdsize+bifsize,
							pcvbbwk+bhdsize+bifsize,
							cnvangle);


	CopyMemory ((PBYTE)pcvbbwk+bhdsize,(PBYTE) pcvbbmp+bhdsize,bifsize);
	bitscalecnv (pcvbbwk+bhdsize,pcvbbmp+bhdsize,cnvscal);
	return 0;
}


int  APIENTRY	BmpColChange(DWORD colno,DWORD rcol,DWORD gcol,DWORD bcol)
{

	int		bhdsize=sizeof(BITMAPFILEHEADER);
	int		bifsize=sizeof(BITMAPINFOHEADER);

	if	(bmapopen_sw == 0)	return 1; 
	if	(!pcvbbmp_len)		return 1;

	if (colno > 20) colno = 20;
	if (rcol > 20 ) rcol = 20;
	if (gcol > 20 ) gcol = 20;
	if (bcol > 20 ) bcol = 20;

	Video_MonoColorSet (pcvbbmp+bhdsize,colno,rcol,gcol,bcol);
	return 0;
}


int  APIENTRY	BitDispWindSet (long no,HWND hWnd)
{

	if (wndsetsw[no]) return 1;
	wndsetsw[no]	=	1;
	disphwnd[no]	=	hWnd;
	dispproc[no]	=	(FARPROC) GetWindowLong (hWnd,GWL_WNDPROC);
	dispptr[no]		=	VirtualAlloc(NULL,ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	dispsize[no]		=	0;
	SetWindowLong (hWnd,GWL_WNDPROC,(LONG) Disp_BitmapProc);
	return 0;
}


int  APIENTRY BitDispWindReset (long no)
{
	HWND	hWnd;

	if (wndsetsw[no]) {
		hWnd = disphwnd[no];
		SetWindowLong (hWnd,GWL_WNDPROC,(LONG) dispproc[no]);
	}
	if (dispptr[no]) {
		VirtualFree( dispptr[no],0,MEM_RELEASE );
	}
	dispptr[no]		=	0;
	dispsize[no]		=	0;
	wndsetsw[no]	=	0;
	return 0;
}

int  APIENTRY ClickMessageSend (HWND wnd)
{
	DWORD	pos;

	pos = MAKELONG(5,5);
	PostMessage (wnd,WM_LBUTTONDOWN,MK_LBUTTON,pos);
	Sleep(5);
	PostMessage (wnd,WM_LBUTTONUP,MK_LBUTTON,pos);
	return 0;

}


//****************************************************************************

static	int GetBmpFile(PBYTE bfnm,PBYTE  bmp,PBYTE pbmbf) 
{

	LPBITMAPFILEHEADER		pbmfhdr;
	LPBITMAPINFOHEADER		pbmaphdr;
	HANDLE	fhndl;
	BOOL	rt;
	DWORD	getsz;
	DWORD	bisize;
	PBYTE	fbmpptr;

	pbmfhdr		= (LPBITMAPFILEHEADER) pbmbf;
	pbmaphdr	= (LPBITMAPINFOHEADER) (pbmbf + sizeof(BITMAPFILEHEADER));
	fbmpptr		= pbmbf + sizeof (BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	fhndl = CreateFile (bfnm,
					GENERIC_READ,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);

	if (fhndl == INVALID_HANDLE_VALUE) {
		return 0;
	}
	rt = ReadFile (fhndl,pbmfhdr,sizeof(BITMAPFILEHEADER),&getsz,0);
	if (pbmfhdr->bfType == 'MB' ) {
		rt = ReadFile (fhndl,pbmaphdr,sizeof(BITMAPINFOHEADER),&getsz,0);
		if (rt) {
			CopyMemory (bmp,(PBYTE) pbmaphdr,sizeof(BITMAPINFOHEADER));
			bisize = pbmfhdr->bfSize - sizeof(BITMAPFILEHEADER) - sizeof(BITMAPINFOHEADER);
			rt = ReadFile (fhndl,(PBYTE)fbmpptr,bisize,&getsz,0); 
			CloseHandle (fhndl);
			return bisize;
		}
	}
	CloseHandle (fhndl);
	return 0;
}



static void Video_Disp (HWND hWnd,LPBYTE buf)
{
	HDC			hDC;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;

		memcpy ((void*) &vfmt,buf,sizeof(BITMAPINFOHEADER));

		GetClientRect (hWnd,&wrect);
		hDC = GetDC (hWnd);
		DrawDibDraw (hdrawdibCvb,
					hDC,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) &vfmt,
					buf+sizeof(BITMAPINFOHEADER),
					0,0,-1,-1,0);

		ReleaseDC (hWnd,hDC);

}

//*****************************************************
//  RGB-24 FORMAT ONLY
//*****************************************************

static int	Video_MonoColorSet (PBYTE rgbbf,long col,long rcol,long gcol,long bcol)
{
	LPBITMAPINFOHEADER	pfmt;
	PBITRGBTBL			prgb;
	int					ken;
	int					pos;
	WORD				rgb;
//	int					bsize;
	PBYTE				pbf;
	double              fcol;
	double				w;
	double				r;
	double				g;
	double				b;
	double				r1;
	double				g1;
	double				b1;
	short				ir;
	short				ig;
	short 				ib;
		

	pbf = (PBYTE) rgbbf;
	pfmt = (LPBITMAPINFOHEADER) pbf;
	prgb = (PBITRGBTBL) (pbf+sizeof(BITMAPINFOHEADER));

	if (pfmt->biBitCount < 12) return 1;			// Not 24 Bit mode
	if (pfmt->biCompression != BI_RGB) return 1;	// Not RGB COLOR
	

	ken = pfmt->biWidth * pfmt->biHeight;
	if (col < 11) {
		//  [hݒ
		fcol = (double) col / 10.0;

		for (pos = 0 ;pos <ken;pos++ ){
			rgb = (WORD) prgb->r +	(WORD) prgb->g + (WORD)prgb->b;
			w = (double) ((int) rgb) / 3.0;		// ϒl
			r =  w - (double) ((int) prgb->r);
			g =  w - (double) ((int) prgb->g);
			b =  w - (double) ((int) prgb->b);
			r1 = w - r * fcol;
			g1 = w - g * fcol;
			b1 = w - b * fcol;
			if (r1 < 0.0) ir = 0;	else ir = (short) r1;
			if (g1 < 0.0) ig = 0;	else ig = (short) g1;
			if (b1 < 0.0) ib = 0;	else ib = (short) b1;
			ir = redset (ir,rcol);
			ig = greset (ig,gcol);
			ib = bleset (ib,bcol);
			prgb->r = LOBYTE (ir);	
			prgb->g = LOBYTE (ig);	
			prgb->b = LOBYTE (ib);
			prgb++;
		}
	} else {
		// 邳ݒ
		fcol = (double) (col - 10) / 10.0;

		for (pos = 0 ;pos <ken;pos++ ){
			rgb = (WORD) prgb->r +	(WORD) prgb->g + (WORD)prgb->b;
			r =  (double) ((int) prgb->r);
			g =  (double) ((int) prgb->g);
			b =  (double) ((int) prgb->b);
			r1 =  r + r * fcol;
			g1 =  g + g * fcol;
			b1 =  b + b * fcol;
			if (r1 > 254.0) ir = 255;	else ir = (short) r1;
			if (g1 > 254.0) ig = 255;	else ig = (short) g1;
			if (b1 > 254.0) ib = 255;	else ib = (short) b1;
			ir = redset (ir,rcol);
			ig = greset (ig,gcol);
			ib = bleset (ib,bcol);
			prgb->r = LOBYTE (ir);	
			prgb->g = LOBYTE (ig);	
			prgb->b = LOBYTE (ib);
			prgb++;
		}
	}

	return 0;
}


static short redset (short ir,long rcol)
{
	double  cl;
	short  ans;
	if (rcol == 10) return  ir;
	else if (rcol < 10) {
		//  F
		cl = (double)rcol / 10.0; 
		ans = (short) ((double) ir * cl);
	} else {
		//  ZF
		cl = (double) (rcol - 10) / 10.0; 
		ans = (short) ((double) ir + (double) ir * cl);
		if (ans > 254) ans = 255;
	}
	return  ans;
}
static short greset (short ig,long gcol)
{
	double  cl;
	short  ans;

	if (gcol == 10) return  ig;
	else if (gcol < 10) {
		//  F
		cl = (double)gcol / 10.0; 
		ans = (short) ((double) ig * cl);
	} else {
		//  ZF
		cl = (double) (gcol - 10) / 10.0; 
		ans = (short) ((double) ig + (double) ig * cl);
		if (ans > 254) ans = 255;

	}
	return  ans;
}
static short bleset (short ib,long bcol)
{
	double  cl;
	short  ans;

	if (bcol == 10) return  ib;
	else if (bcol < 10) {
		//  F
		cl = (double)bcol / 10.0; 
		ans = (short) ((double) ib * cl);
	} else {
		//  ZF
		cl = (double) (bcol - 10) / 10.0; 
		ans = (short) ((double) ib + (double) ib * cl);
		if (ans > 254) ans = 255;

	}
	return  ans;
}


static int Get_bmtfile (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf)
{

	int					rtcd;
	DWORD				size;
//*****   work
	int					i,j;
	DWORD				ln;
	int					ncol;
    int                 sz;

//************ ͗p
	HDC					in_hDC;
	BITMAP				in_bm;
	HBITMAP				in_hbmp;

//************ p
	RECT				wrect;
	HDC					mem_hDC;
	HBITMAP				mem_hbmp;


//***********  bitmap aria
    LPBYTE				to_hbit;
	LPBITMAPINFOHEADER	to_bithed;
	LPRGBQUAD			to_bitcol;
	PBYTE	drwtbl;
	BITMAPINFOHEADER	bfmt;
	PRGB32BITTBL		p32tbl;
	PRGB24BITTBL		p24tbl;
	PRGB16BITTBL		p16tbl;
	RGB24BITTBL		in24tbl;
	RGB24BITTBL		ot24tbl;

	in_hDC		=	GetDC (hwnd);
//	GetClientRect	  (hwnd,&rect);
	wrect.right  = pvfmt->biWidth ;
	wrect.bottom = pvfmt->biHeight ;
	wrect.left = 0;
	wrect.top  = 0;
	in_hbmp		=	CreateCompatibleBitmap (in_hDC,wrect.right,wrect.bottom);
	GetObject  (in_hbmp,sizeof(BITMAP),(LPSTR)&in_bm);

	mem_hDC		=	CreateCompatibleDC(in_hDC);
	SetMapMode (mem_hDC,GetMapMode (in_hDC));

	mem_hbmp =  (HBITMAP) SelectObject  (mem_hDC,in_hbmp);

	DrawDibDraw (hdrawdibCvb,
				mem_hDC,
				wrect.left,
				wrect.top,
				wrect.right  - wrect.left,
				wrect.bottom - wrect.top,
				(LPBITMAPINFOHEADER) pvfmt,
				pt+sizeof(BITMAPINFOHEADER),
				0,0,-1,-1,0);

	SelectObject  (mem_hDC,mem_hbmp);

	drwtbl = DrawDibGetBuffer(hdrawdibCvb, &bfmt,sizeof(BITMAPINFOHEADER),0); 

	to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);

	size = bfmt.biHeight * bfmt.biWidth * 3;
	if (drwtbl) {
		if (bfmt.biBitCount  == 32 && bfmt.biCompression == 0) {
		// convert 32-> 24
			p32tbl = (PRGB32BITTBL) drwtbl;
			p24tbl = (PRGB24BITTBL) to_hbit;
			for (i=0;i<bfmt.biHeight;i++) {
				for (j=0;j<bfmt.biWidth;j++) {
					p24tbl->r  = p32tbl->r;
					p24tbl->g  = p32tbl->g;
					p24tbl->b  = p32tbl->b;
					p24tbl++;
					p32tbl++;
				}
			}
		} else if (bfmt.biBitCount  == 24 && bfmt.biCompression == 0) {
			CopyMemory (to_hbit,drwtbl,size);
		} else if (bfmt.biBitCount  == 16 && bfmt.biCompression == 3) {
			WORD	r,g,b;

			p16tbl = (PRGB16BITTBL) drwtbl;
			p24tbl = (PRGB24BITTBL) to_hbit;
			for (i=0;i<bfmt.biHeight;i++) { 
				for (j=0;j<bfmt.biWidth;j++) { 
					b  = p16tbl->rgb & 0x001f;		// 5 bit
					g  = p16tbl->rgb & 0x07e0;		// 6 bit 
					r  = p16tbl->rgb & 0xf800;		// 5 bit
					in24tbl.b  = LOBYTE (b);			// 5 bit
					in24tbl.g  = LOBYTE (g >> 5);		// 6 bit 
					in24tbl.r  = LOBYTE (r >> 11);		// 5 bit

//					b  = p16tbl->rgb & 0x001f;		// 5 bit
//					g  = p16tbl->rgb & 0x03e0;		// 5 bit 
//					r  = p16tbl->rgb & 0x7c00;		// 5 bit
//					in24tbl.b  = LOBYTE (b);			// 5 bit
//					in24tbl.g  = LOBYTE (g >> 5);		// 5 bit 
//					in24tbl.r  = LOBYTE (r >> 10);		// 5 bit

					Conv16To24 (&in24tbl,&ot24tbl);
					p24tbl->r  = ot24tbl.r;
					p24tbl->g  = ot24tbl.g;
					p24tbl->b  = ot24tbl.b;
			
					p24tbl++;
					p16tbl++;
				}
			}
		
		} else {
			DeleteObject (in_hbmp);
			DeleteObject (mem_hbmp);
			DeleteDC	 (mem_hDC);
			ReleaseDC    (hwnd,in_hDC);
			size = 0;
			return size;
		}
		memset (buf,0,sizeof(BITMAPINFOHEADER));
		to_bithed	=	(LPBITMAPINFOHEADER) buf;
		to_bitcol	=	(LPRGBQUAD) (buf + sizeof(BITMAPINFOHEADER));

		to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);
		to_bithed->biWidth	=	in_bm.bmWidth;
		to_bithed->biHeight	=	in_bm.bmHeight;
		to_bithed->biPlanes	=	1;
		to_bithed->biBitCount=	24;
		to_bithed->biCompression =	BI_RGB;
		to_bithed->biSizeImage = size;
	} else {
		ncol = in_bm.bmPlanes * in_bm.bmBitsPixel;
		if  (ncol <= 1) {
			ncol = 1;
			sz  = 1;
		}
		else if (ncol <= 4 ) {
			ncol = 4;
			sz  = 16;
		}
		else if (ncol <= 8 ) {
			ncol = 8;
			sz  = 256;
		}
		else {
			ncol = 24;
			sz  = 1024;
		}

		memset (buf,0,sizeof(BITMAPINFOHEADER));
		to_bithed	=	(LPBITMAPINFOHEADER) buf;
		to_bitcol	=	(LPRGBQUAD) buf + sizeof(BITMAPINFOHEADER);
		if (ncol == 24) {
			ln	=	0;
			to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);
		}
		else {
			ln 		=	(sz * sizeof(RGBQUAD));
			(LPBYTE)to_hbit		= (LPBYTE)buf + sizeof(BITMAPINFOHEADER) + (sz * sizeof(RGBQUAD));
		}

		to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);

		to_bithed->biWidth	=	in_bm.bmWidth;
		to_bithed->biHeight	=	in_bm.bmHeight;

//		to_bithed->biPlanes	=	in_bm.bmPlanes;
		to_bithed->biPlanes	=	1;
//		to_bithed->biBitCount=	in_bm.bmBitsPixel;
		to_bithed->biBitCount=	ncol;
		to_bithed->biCompression =	BI_RGB;
		to_bithed->biSizeImage = size;

  		rtcd = GetDIBits ( mem_hDC,in_hbmp,0,in_bm.bmHeight,
				to_hbit,
				(LPBITMAPINFO) to_bithed,
				DIB_RGB_COLORS);
	}

	DeleteObject (in_hbmp);
	DeleteObject (mem_hbmp);
	DeleteDC	 (mem_hDC);
	ReleaseDC    (hwnd,in_hDC);
	size = to_bithed->biSizeImage;
	return size;

}

static void	Conv16To24 (PRGB24BITTBL intbl,PRGB24BITTBL ottbl)
{

	double  r,g,b;

	r = (double) intbl->r / 31.0;
	g = (double) intbl->g / 63.0;
	b = (double) intbl->b / 31.0;
	ottbl->r  = LOBYTE ((WORD)(255.0 * r));
	ottbl->g  = LOBYTE ((WORD)(255.0 * g));
	ottbl->b  = LOBYTE ((WORD)(255.0 * b));

}


//*****************************************************
//  RGB-24 FORMAT ONLY
//*****************************************************
static int	bitscalecnv (PBYTE ibf,PBYTE obf,int scl)
{
	LPBITMAPINFOHEADER	pbfmt;
	int		size;
	int		iysize,ixsize;
	int		ixst,ixed;
	int		iyst,iyed;
	int		iypt,ixpt;
	int		cysize,cxsize;
	int		i,j;
	int		xpos,ypos;
	double  yl,xl;
	struct rgbtbl {
		BYTE  b;
		BYTE  g;
		BYTE  r;
	} ;
	struct rgbtbl	*pirgb;
	struct rgbtbl	*porgb;
	PBYTE	pt;
	PBYTE	ipt = ibf+sizeof(BITMAPINFOHEADER);

	pirgb = (struct rgbtbl	*) (ibf+sizeof(BITMAPINFOHEADER));
	porgb = (struct rgbtbl	*) (obf+sizeof(BITMAPINFOHEADER));

	pbfmt =(LPBITMAPINFOHEADER) ibf;
	size = pbfmt->biHeight * pbfmt->biWidth * 3;
	if (scl < 1 || scl > 9) {
		CopyMemory (obf,ibf,size+sizeof(BITMAPINFOHEADER));
		return size;
	}
	if (pbfmt->biCompression != BI_RGB) return 0;
	if (pbfmt->biBitCount != 24) return 0;

	CopyMemory (obf+sizeof(BITMAPINFOHEADER),ibf+sizeof(BITMAPINFOHEADER),sizeof(BITMAPINFOHEADER));
	iysize = pbfmt->biHeight ;
	ixsize = pbfmt->biWidth ;

	ixpt = ixsize / 2;
	iypt = iysize / 2;

	cxsize = (int) (floor((double) ixsize * scl/10.0));
	cysize = (int) (floor((double) iysize * scl/10.0));

	ixst = ixpt - (int) floor((cxsize / 2.0));
	ixed = ixpt + (int) floor((cxsize / 2.0));
	iyst = iypt - (int) floor((cysize / 2.0));
	iyed = iypt + (int) floor((cysize / 2.0));
	yl = (double) iysize / (double) cysize;
	xl = (double) ixsize / (double) cxsize;
	for (i=0;i<iysize;i++) {
		ypos = iyst + (int) floor(i/yl);
		for (j=0;j<ixsize;j++) {
			xpos = ixst + (int) floor(j/xl);
			pt =ipt+(xpos*3) + (ypos*ixsize*3);
			pirgb = (struct rgbtbl	*) pt;
			porgb->r =  pirgb->r;
			porgb->g =  pirgb->g;
			porgb->b =  pirgb->b;
			porgb++;
		}
	}
	
	
	return size;
}


//*****************************************************
//  RGB-24 FORMAT ONLY
//*****************************************************
void bitmap_angle(LPBITMAPINFOHEADER pfmt,PBYTE	ibf,PBYTE	obf,int scl) { /* rbg}bvɑ΂] */

	int		i,j,xx,yy;
	int		ixsize;
	int		bmpx,bmpy;
	int		bmpsz;
	double dscl;
	double	pai=3.141592654;
	double cos_dt;
	double sin_dt;
	
	/* rbg}bv̑傫ۑ */
	bmpx	=	pfmt->biWidth;
	bmpy	=	pfmt->biHeight;
	if (pfmt->biBitCount != 24) {
		return ;
	}
	if (scl == 18) {		// no convert
		bmpsz = bmpx * bmpy * 3;
		CopyMemory (obf,ibf,bmpsz);
		return ;
	} else if (scl < 18) {
		dscl = (double) ((18 - scl) * 10) * (pai / 180.0);
		dscl = -dscl;
	} else if (scl < 37) {
		dscl = (double) ((scl - 18) * 10) * (pai / 180.0);
	} else {
					// no convert
		bmpsz = bmpx * bmpy * 3;
		CopyMemory (obf,ibf,bmpsz);
		return ;
	}
	cos_dt = cos(dscl);
	sin_dt = sin(dscl);

	if ((bmpx*3) % 4==0) {/* obt@̂PC̒vZ */
		ixsize=bmpx * 3;
	} else {
		ixsize=bmpx * 3+(4-(bmpx*3) % 4);
	}
	
	FillMemory(obf,ixsize*bmpy,0xff);

	// dscl = -0.3 TEST

	for (i=0;i<bmpy;i++)  /* rbg}bv] */
		for (j=0;j<bmpx;j++) {

			/* ]̃sNZɑΉ]ÕsNZvZ */
			xx=(int)((j-bmpx/2)*cos_dt-(i-bmpy/2)*sin_dt)+bmpx/2;
			yy=(int)((j-bmpx/2)*sin_dt+(i-bmpy/2)*cos_dt)+bmpy/2;

			/* ]̃sNZɁAΉ]ÕsNZ` */
			if (xx>=0 && yy>=0 && xx<bmpx && yy<bmpy)
				CopyMemory(obf+j*3+i*ixsize,ibf+xx*3+yy*ixsize,3);

		}
}

static	long WINAPI   Disp_BitmapProc (HWND		hWnd,
									   UINT		iMessage,
									   WPARAM	wParam,
									   LPARAM	lParam)

{

	HDC			hDc;
//	PAINTSTRUCT ps;
	int			widx;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;
	PBYTE		pt;
	FARPROC		Old_Proc;

	widx = DispWndChk (hWnd);
	if (widx == 0) {
		return DefWindowProc (hWnd,iMessage,wParam,lParam) ;
	}
	widx--;
	if (dispsize[widx] == 0) return DefWindowProc (hWnd,iMessage,wParam,lParam) ;
	pt = dispptr[widx] + sizeof(BITMAPFILEHEADER);
	Old_Proc = dispproc[widx];
	switch (iMessage)  {
		case	WM_USER+2222:
			GetClientRect (hWnd,&wrect);
			hDc		=	GetDC (hWnd);
			memcpy ((void*) &vfmt,pt,sizeof(BITMAPINFOHEADER));
			DrawDibDraw (hdrawdibCvb,
					hDc,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) &vfmt,
					pt+sizeof(BITMAPINFOHEADER),
					0,0,-1,-1,0);
			ReleaseDC(hWnd,hDc);
			return 		FALSE;
		case WM_PAINT:
			PostMessage (hWnd,WM_USER+2222,0,0);	// Triger
			break;
	}
	return  CallWindowProc ((WNDPROC) Old_Proc,hWnd,iMessage,wParam,lParam);

}

static	int	DispWndChk (HWND hWnd)
{
	int		i;

	for (i=0;i<VIDEO_TABLEMAX;i++) {
		if (hWnd == disphwnd[i]) {
			return i+1;
		}
	}
	return 0;
}

